/*
state2 indicator version 1.0
(part of jsgraphics library)

Dim: 54px x 28px

Interface
---------

[Intervals 1, 2, 3, 4, 5, 6]
int1_min =
int1_max =
int1_color =

int2_min =
int2_max =
int2_color =
...

[Type]
1 - circle
2 - rect

[Alert]
alertmin =
alertmax =

[Theme]
Black*
this.background = 'rgba(0, 0, 0, 1)';
this.color_title = 'rgba(220, 220, 220, 1)';
White
this.background = 'rgba(255, 255, 255, 1)';
this.color_title = 'rgba(60, 60, 60, 1)';

Notes
-----

'rgba(230, 230, 50, 1)';} // yellow
'rgba(225, 60, 50, 1)';} // red
'rgba(210, 160, 50, 1)';} // orange
'rgba(50, 200, 50, 1)';} // green
'rgba(140, 140, 225, 1)';} // blue
'rgba(50, 230, 230, 1)';} // cyan

*/

// ------------------------ state2()

function state2(contid, objprop, title, refreshtime, type) {
	this.contid = contid;
	this.objprop = objprop;
	this.title = title;
	this.refreshtime = refreshtime;
	this.type = type;	
  
	this.lenX = 54;	
	this.lenY = 28;	
  
	this.title_font = '11px Tahoma';
	this.value_font = '26px Tahoma';
	
	this.background = 'rgba(44, 44, 44, 1)';
  this.background_over = 'rgba(44, 44, 44, 1)';
	this.color_title = 'rgba(160, 160, 160, 1)';
  this.color_title_active = 'rgba(240, 240, 240, 1)';
	
	this.color_unknown = '#444444';
	this.color = this.color_unknown;
	
	this.int1_min = 0; this.int1_max = 0; this.int1_color = this.color_unknown;
	this.int2_min = 0; this.int2_max = 0; this.int2_color = this.color_unknown;
	this.int3_min = 0; this.int3_max = 0; this.int3_color = this.color_unknown;
	this.int4_min = 0; this.int4_max = 0; this.int4_color = this.color_unknown;
	this.int5_min = 0; this.int5_max = 0; this.int5_color = this.color_unknown;
	this.int6_min = 0; this.int6_max = 0; this.int6_color = this.color_unknown;
  
  this.bg = 1;	
  this.ov = 0;
  
	var self = this;
  
  // ------------ Actions
  
	this.canvas_mouseover = function() {
    self.ov = 1;
    self.redraw();
	}  
  
	this.canvas_mouseout = function() {
    self.ov = 0;
    self.redraw();
	}    
  
	this.canvas_click = function() {
		//console.log(self.context);
    
    if (self.bg == 1) {self.bg = 2;} 
                 else {self.bg = 1;}    
    
    self.redraw();
	};  
  
  // ------------ Redraw
	
	this.redraw = function() {  
  
		// Bind actions
		document.getElementById(this.contid).onclick = this.canvas_click;
		document.getElementById(this.contid).onmouseover = this.canvas_mouseover;     
    document.getElementById(this.contid).onmouseout = this.canvas_mouseout;
    
		// Background
    this.context.clearRect(0, 0, this.lenX, this.lenY);
    
    if (this.bg == 1) {
      this.context.fillStyle = this.background;
      
      if (this.ov == 1) {
        this.context.fillStyle = 'rgba(77, 77, 77, 1)';
      }

    } else {
      this.context.fillStyle = this.background_over;
    }
    
		this.context.fillRect(0, 0, this.lenX, this.lenY);
	
		this.color = this.color_unknown;

		if (this.value >= this.int1_min && this.value <= this.int1_max) {this.color = this.int1_color;}
		if (this.value >= this.int2_min && this.value <= this.int2_max) {this.color = this.int2_color;}
		if (this.value >= this.int3_min && this.value <= this.int3_max) {this.color = this.int3_color;}
		if (this.value >= this.int4_min && this.value <= this.int4_max) {this.color = this.int4_color;}
		if (this.value >= this.int5_min && this.value <= this.int5_max) {this.color = this.int5_color;}
		if (this.value >= this.int6_min && this.value <= this.int6_max) {this.color = this.int6_color;}
	
    
  
  
    if (this.bg == 1) {
      this.color = this.color_unknown;
    } else {
      this.color = this.int1_color;
    } 
  
  
  
		this.context.fillStyle = this.color;
		this.context.textAlign = "center";  	
	
		// Alert
		if (this.value != '') {    
			if ((this.alertstate != 0) && (this.alertframe == 0) ) {
				this.context.fillStyle = this.color_unknown;
			} else {
				this.context.fillStyle = this.color;
			}
		}
		
		// Led
		this.context.font = this.value_font;
	
		if (this.type == 2) {
			this.context.fillText('●', 34, 28);
		} else {
			this.context.fillRect(0, 23, 54, 5);

		}
		
		// Title
		this.context.font = this.title_font;
		//this.context.fillStyle = this.color_title;
    
    if (this.bg == 1) {
      this.context.fillStyle = this.color_title;
    } else {
      this.context.fillStyle = this.color_title_active;
    }    
    
   // this.title = this.value;
		this.context.fillText(this.title, 27, 16, 80); 

    
    
	} // redraw()

	this.init();
  
} // state1()

state2.prototype = new jsgraphics_alertobject;